// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"gochassis/ent/profile"
	"strings"
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// Profile is the model entity for the Profile schema.
type Profile struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// PhoneNumber holds the value of the "phone_number" field.
	PhoneNumber string `json:"phone_number,omitempty"`
	// DeviceID holds the value of the "device_id" field.
	DeviceID string `json:"device_id,omitempty"`
	// Displayname holds the value of the "displayname" field.
	Displayname string `json:"displayname,omitempty"`
	// Password holds the value of the "password" field.
	Password string `json:"-"`
	// BirthYear holds the value of the "birth_year" field.
	BirthYear int16 `json:"birth_year,omitempty"`
	// Gender holds the value of the "gender" field.
	Gender string `json:"gender,omitempty"`
	// CreatedAt holds the value of the "created_at" field.
	CreatedAt time.Time `json:"created_at,omitempty"`
	// UpdatedAt holds the value of the "updated_at" field.
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// DeletedAt holds the value of the "deleted_at" field.
	DeletedAt time.Time `json:"deleted_at,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ProfileQuery when eager-loading is set.
	Edges        ProfileEdges `json:"edges"`
	selectValues sql.SelectValues
}

// ProfileEdges holds the relations/edges for other nodes in the graph.
type ProfileEdges struct {
	// Chats holds the value of the chats edge.
	Chats []*Chat `json:"chats,omitempty"`
	// ChatRooms holds the value of the chat_rooms edge.
	ChatRooms []*ChatRoom `json:"chat_rooms,omitempty"`
	// Posts holds the value of the posts edge.
	Posts []*Post `json:"posts,omitempty"`
	// Likes holds the value of the likes edge.
	Likes []*Post `json:"likes,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [4]bool
}

// ChatsOrErr returns the Chats value or an error if the edge
// was not loaded in eager-loading.
func (e ProfileEdges) ChatsOrErr() ([]*Chat, error) {
	if e.loadedTypes[0] {
		return e.Chats, nil
	}
	return nil, &NotLoadedError{edge: "chats"}
}

// ChatRoomsOrErr returns the ChatRooms value or an error if the edge
// was not loaded in eager-loading.
func (e ProfileEdges) ChatRoomsOrErr() ([]*ChatRoom, error) {
	if e.loadedTypes[1] {
		return e.ChatRooms, nil
	}
	return nil, &NotLoadedError{edge: "chat_rooms"}
}

// PostsOrErr returns the Posts value or an error if the edge
// was not loaded in eager-loading.
func (e ProfileEdges) PostsOrErr() ([]*Post, error) {
	if e.loadedTypes[2] {
		return e.Posts, nil
	}
	return nil, &NotLoadedError{edge: "posts"}
}

// LikesOrErr returns the Likes value or an error if the edge
// was not loaded in eager-loading.
func (e ProfileEdges) LikesOrErr() ([]*Post, error) {
	if e.loadedTypes[3] {
		return e.Likes, nil
	}
	return nil, &NotLoadedError{edge: "likes"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Profile) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case profile.FieldID, profile.FieldBirthYear:
			values[i] = new(sql.NullInt64)
		case profile.FieldPhoneNumber, profile.FieldDeviceID, profile.FieldDisplayname, profile.FieldPassword, profile.FieldGender:
			values[i] = new(sql.NullString)
		case profile.FieldCreatedAt, profile.FieldUpdatedAt, profile.FieldDeletedAt:
			values[i] = new(sql.NullTime)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Profile fields.
func (pr *Profile) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case profile.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			pr.ID = int(value.Int64)
		case profile.FieldPhoneNumber:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field phone_number", values[i])
			} else if value.Valid {
				pr.PhoneNumber = value.String
			}
		case profile.FieldDeviceID:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field device_id", values[i])
			} else if value.Valid {
				pr.DeviceID = value.String
			}
		case profile.FieldDisplayname:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field displayname", values[i])
			} else if value.Valid {
				pr.Displayname = value.String
			}
		case profile.FieldPassword:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field password", values[i])
			} else if value.Valid {
				pr.Password = value.String
			}
		case profile.FieldBirthYear:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field birth_year", values[i])
			} else if value.Valid {
				pr.BirthYear = int16(value.Int64)
			}
		case profile.FieldGender:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field gender", values[i])
			} else if value.Valid {
				pr.Gender = value.String
			}
		case profile.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				pr.CreatedAt = value.Time
			}
		case profile.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				pr.UpdatedAt = value.Time
			}
		case profile.FieldDeletedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field deleted_at", values[i])
			} else if value.Valid {
				pr.DeletedAt = value.Time
			}
		default:
			pr.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the Profile.
// This includes values selected through modifiers, order, etc.
func (pr *Profile) Value(name string) (ent.Value, error) {
	return pr.selectValues.Get(name)
}

// QueryChats queries the "chats" edge of the Profile entity.
func (pr *Profile) QueryChats() *ChatQuery {
	return NewProfileClient(pr.config).QueryChats(pr)
}

// QueryChatRooms queries the "chat_rooms" edge of the Profile entity.
func (pr *Profile) QueryChatRooms() *ChatRoomQuery {
	return NewProfileClient(pr.config).QueryChatRooms(pr)
}

// QueryPosts queries the "posts" edge of the Profile entity.
func (pr *Profile) QueryPosts() *PostQuery {
	return NewProfileClient(pr.config).QueryPosts(pr)
}

// QueryLikes queries the "likes" edge of the Profile entity.
func (pr *Profile) QueryLikes() *PostQuery {
	return NewProfileClient(pr.config).QueryLikes(pr)
}

// Update returns a builder for updating this Profile.
// Note that you need to call Profile.Unwrap() before calling this method if this Profile
// was returned from a transaction, and the transaction was committed or rolled back.
func (pr *Profile) Update() *ProfileUpdateOne {
	return NewProfileClient(pr.config).UpdateOne(pr)
}

// Unwrap unwraps the Profile entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (pr *Profile) Unwrap() *Profile {
	_tx, ok := pr.config.driver.(*txDriver)
	if !ok {
		panic("ent: Profile is not a transactional entity")
	}
	pr.config.driver = _tx.drv
	return pr
}

// String implements the fmt.Stringer.
func (pr *Profile) String() string {
	var builder strings.Builder
	builder.WriteString("Profile(")
	builder.WriteString(fmt.Sprintf("id=%v, ", pr.ID))
	builder.WriteString("phone_number=")
	builder.WriteString(pr.PhoneNumber)
	builder.WriteString(", ")
	builder.WriteString("device_id=")
	builder.WriteString(pr.DeviceID)
	builder.WriteString(", ")
	builder.WriteString("displayname=")
	builder.WriteString(pr.Displayname)
	builder.WriteString(", ")
	builder.WriteString("password=<sensitive>")
	builder.WriteString(", ")
	builder.WriteString("birth_year=")
	builder.WriteString(fmt.Sprintf("%v", pr.BirthYear))
	builder.WriteString(", ")
	builder.WriteString("gender=")
	builder.WriteString(pr.Gender)
	builder.WriteString(", ")
	builder.WriteString("created_at=")
	builder.WriteString(pr.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(pr.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("deleted_at=")
	builder.WriteString(pr.DeletedAt.Format(time.ANSIC))
	builder.WriteByte(')')
	return builder.String()
}

// Profiles is a parsable slice of Profile.
type Profiles []*Profile
